/**四舍六入奇进偶不进 */
export function handleNumber(number, fixed = 0) {
  number = String(number);
  //可以考虑清掉末尾的0，暂时限制了不会有,因为传入数值，末尾0是去掉的
  let index = number.indexOf('.');
  if (index == -1) {
    //没有小数，直接返回
    return number;
  }
  //取到保留小数位的下一位，5.5555取保留俩位，那就是小数点后第三位
  let indexFixed = index + fixed + 1;
  if (indexFixed >= number.length) {
    //如果小数位数不够直接返回
    return number;
  }
  //取保留位数的后一位做判断，以下是有5的判断
  let endNumber = number.substr(indexFixed, 1);
  if (endNumber != '5') {
    //如果做判断的数不是五，就按正常的四舍五入，即忽略了5，后面补0的那些由于是数字传进来，0已经去掉，此处不做处理
    return Number(number).toFixed(fixed);
  }
  if (indexFixed != number.length - 1) {
    //由于当前判断位不是最后一位，而又去除了0，那么后面后的位数应该直接入位，五后不为0时入,由于会有小于五的，四舍五入肯定不行，那么只能截取到当前保留位数，然后转成数字加上10的负fixed的次方即可
    number = number.substring(0, indexFixed);
    return (Number(number) + Number(Math.pow(10, -fixed))).toFixed(fixed);
    //return this.accAdd(number,Math.pow(10,-fixed))
  }
  //接下来就时五后没有值也就是0的需要看前面的奇入偶不入了，取当前位的上一位
  let twoNumber = number.substr(indexFixed - 1, 1);
  if ('13579'.indexOf(twoNumber) != -1) {
    //奇进
    number = number.substring(0, indexFixed);
    return (Number(number) + Math.pow(10, -fixed)).toFixed(fixed);
  }
  //偶不进,将取值的当前位数,直接截取字符即可
  return number.substr(0, indexFixed);
}
// 计算平均值
export function formatAvg(arr, digits = 1) {
  const sum = arr.reduce((a, b) => a + b);
  const average = sum / arr.length;
  return handleNumber(average, digits);
}

/**计算示值误差 */
export function formatError(a, c, digits = 1) {
  if (a == null || a == undefined || a == '') return null;
  const val = (a - c) / c;
  const result = val * 100;
  return handleNumber(result, digits);
}
/**计算系统偏差 */
export function formatDeviation(a, b, c, digits = 1) {
  if (
    a == null ||
    a == undefined ||
    a == '' ||
    b == null ||
    b == undefined ||
    b == ''
  )
    return null;
  const value = (b - a) / c;
  const deviationVal = value * 100;
  return handleNumber(deviationVal, digits);
}

/**计算零点漂移绝对误差
 * a 起始（Z0）
 * b 最终（Zi）
 */
export function formatZeroDrift(a, b, digits = 1) {
  const diffValue = Number(b) - Number(a);
  return handleNumber(diffValue, digits);
}

/**计算校准量程
 * a 零点漂移绝对误差
 * b 浓度值
 */
export function formatZeroRange(a, b, digits = 1) {
  const diffValue = Number(a) / Number(b);
  return handleNumber(diffValue, digits);
}

/**原始数据 */
export const dataList = [
  {
    sort: 1,
    gasesName: 'NO',
    gasesConcentration: '49.62',
    determineBeforeA1: '', //测定前
    determineBeforeA2: '',
    determineBeforeA3: '',
    determineBeforeAAvg: '',
    determineBeforeB1: '',
    determineBeforeB2: '',
    determineBeforeB3: '',
    determineBeforeBAvg: '',
    determineBeforeError: '',
    determineBeforeDeviation: '',
    determineAfterA1: '', //测定后
    determineAfterA2: '',
    determineAfterA3: '',
    determineAfterAAvg: '',
    determineAfterB1: '',
    determineAfterB2: '',
    determineAfterB3: '',
    determineAfterBAvg: '',
    determineAfterError: '', //误差
    determineAfterDeviation: '', //偏差
  },
  {
    sort: 2,
    gasesName: 'NO',
    gasesConcentration: '19.63',
    determineBeforeA1: '', //测定前
    determineBeforeA2: '',
    determineBeforeA3: '',
    determineBeforeAAvg: '',
    determineBeforeB1: '',
    determineBeforeB2: '',
    determineBeforeB3: '',
    determineBeforeBAvg: '',
    determineBeforeError: '',
    determineBeforeDeviation: '',
    determineAfterA1: '', //测定后
    determineAfterA2: '',
    determineAfterA3: '',
    determineAfterAAvg: '',
    determineAfterB1: '',
    determineAfterB2: '',
    determineAfterB3: '',
    determineAfterBAvg: '',
    determineAfterError: '', //误差
    determineAfterDeviation: '', //偏差
  },
  {
    sort: 3,
    gasesName: 'NO₂',
    gasesConcentration: '30.15',
    determineBeforeA1: '', //测定前
    determineBeforeA2: '',
    determineBeforeA3: '',
    determineBeforeAAvg: '',
    determineBeforeB1: '',
    determineBeforeB2: '',
    determineBeforeB3: '',
    determineBeforeBAvg: '',
    determineBeforeError: '',
    determineBeforeDeviation: '',
    determineAfterA1: '', //测定后
    determineAfterA2: '',
    determineAfterA3: '',
    determineAfterAAvg: '',
    determineAfterB1: '',
    determineAfterB2: '',
    determineAfterB3: '',
    determineAfterBAvg: '',
    determineAfterError: '', //误差
    determineAfterDeviation: '', //偏差
  },
  {
    sort: 4,
    gasesName: 'SO₂',
    gasesConcentration: '10.02',
    determineBeforeA1: '', //测定前
    determineBeforeA2: '',
    determineBeforeA3: '',
    determineBeforeAAvg: '',
    determineBeforeB1: '',
    determineBeforeB2: '',
    determineBeforeB3: '',
    determineBeforeBAvg: '',
    determineBeforeError: '',
    determineBeforeDeviation: '',
    determineAfterA1: '', //测定后
    determineAfterA2: '',
    determineAfterA3: '',
    determineAfterAAvg: '',
    determineAfterB1: '',
    determineAfterB2: '',
    determineAfterB3: '',
    determineAfterBAvg: '',
    determineAfterError: '', //误差
    determineAfterDeviation: '', //偏差
  },
  {
    sort: 5,
    gasesName: 'CO',
    gasesConcentration: '100',
    determineBeforeA1: '', //测定前
    determineBeforeA2: '',
    determineBeforeA3: '',
    determineBeforeAAvg: '',
    determineBeforeB1: '',
    determineBeforeB2: '',
    determineBeforeB3: '',
    determineBeforeBAvg: '',
    determineBeforeError: '',
    determineBeforeDeviation: '',
    determineAfterA1: '', //测定后
    determineAfterA2: '',
    determineAfterA3: '',
    determineAfterAAvg: '',
    determineAfterB1: '',
    determineAfterB2: '',
    determineAfterB3: '',
    determineAfterBAvg: '',
    determineAfterError: '', //误差
    determineAfterDeviation: '', //偏差
  },
  {
    sort: 6,
    gasesName: 'O₂',
    gasesConcentration: '10.1%',
    determineBeforeA1: '', //测定前
    determineBeforeA2: '',
    determineBeforeA3: '',
    determineBeforeAAvg: '',
    determineBeforeB1: '',
    determineBeforeB2: '',
    determineBeforeB3: '',
    determineBeforeBAvg: '',
    determineBeforeError: '',
    determineBeforeDeviation: '',
    determineAfterA1: '', //测定后
    determineAfterA2: '',
    determineAfterA3: '',
    determineAfterAAvg: '',
    determineAfterB1: '',
    determineAfterB2: '',
    determineAfterB3: '',
    determineAfterBAvg: '',
    determineAfterError: '', //误差
    determineAfterDeviation: '', //偏差
  },
];
/**零点量程数据 */
export const driftList = [
  {
    sort: 1,
    gasesName: 'NO',
    gasesConcentration: '49.62',
    startTime1: '', //零点漂移起始时间
    endTime1: '',
    zeroDriftStart1: '',
    zeroDriftEnd1: '',
    zeroDriftError1: '', //误差
    zeroDriftRange1: '', //量程
    spanDriftStart1: '', //量程漂移起始1
    spanDriftEnd1: '', //最终1
    spanDriftError1: '', //绝对误差
    spanDriftRange1: '', //标准量程
    startTime2: '',
    endTime2: '',
    zeroDriftStart2: '',
    zeroDriftEnd2: '',
    zeroDriftError2: '',
    zeroDriftRange2: '',
    spanDriftStart2: '',
    spanDriftEnd2: '',
    spanDriftError2: '',
    spanDriftRange2: '',
    startTime3: '',
    endTime3: '',
    zeroDriftStart3: '',
    zeroDriftEnd3: '',
    zeroDriftError3: '',
    zeroDriftRange3: '',
    spanDriftStart3: '',
    spanDriftEnd3: '',
    spanDriftError3: '',
    spanDriftRange3: '',
  },
  {
    sort: 2,
    gasesName: 'NO',
    gasesConcentration: '19.63',
    startTime1: '', //零点漂移起始时间
    endTime1: '',
    zeroDriftStart1: '',
    zeroDriftEnd1: '',
    zeroDriftError1: '', //误差
    zeroDriftRange1: '', //量程
    spanDriftStart1: '', //量程漂移起始1
    spanDriftEnd1: '', //最终1
    spanDriftError1: '', //绝对误差
    spanDriftRange1: '', //标准量程
    startTime2: '',
    endTime2: '',
    zeroDriftStart2: '',
    zeroDriftEnd2: '',
    zeroDriftError2: '',
    zeroDriftRange2: '',
    spanDriftStart2: '',
    spanDriftEnd2: '',
    spanDriftError2: '',
    spanDriftRange2: '',
    startTime3: '',
    endTime3: '',
    zeroDriftStart3: '',
    zeroDriftEnd3: '',
    zeroDriftError3: '',
    zeroDriftRange3: '',
    spanDriftStart3: '',
    spanDriftEnd3: '',
    spanDriftError3: '',
    spanDriftRange3: '',
  },
  {
    sort: 3,
    gasesName: 'NO₂',
    gasesConcentration: '30.15',
    startTime1: '', //零点漂移起始时间
    endTime1: '',
    zeroDriftStart1: '',
    zeroDriftEnd1: '',
    zeroDriftError1: '', //误差
    zeroDriftRange1: '', //量程
    spanDriftStart1: '', //量程漂移起始1
    spanDriftEnd1: '', //最终1
    spanDriftError1: '', //绝对误差
    spanDriftRange1: '', //标准量程
    startTime2: '',
    endTime2: '',
    zeroDriftStart2: '',
    zeroDriftEnd2: '',
    zeroDriftError2: '',
    zeroDriftRange2: '',
    spanDriftStart2: '',
    spanDriftEnd2: '',
    spanDriftError2: '',
    spanDriftRange2: '',
    startTime3: '',
    endTime3: '',
    zeroDriftStart3: '',
    zeroDriftEnd3: '',
    zeroDriftError3: '',
    zeroDriftRange3: '',
    spanDriftStart3: '',
    spanDriftEnd3: '',
    spanDriftError3: '',
    spanDriftRange3: '',
  },
  {
    sort: 4,
    gasesName: 'SO₂',
    gasesConcentration: '10.02',
    startTime1: '', //零点漂移起始时间
    endTime1: '',
    zeroDriftStart1: '',
    zeroDriftEnd1: '',
    zeroDriftError1: '', //误差
    zeroDriftRange1: '', //量程
    spanDriftStart1: '', //量程漂移起始1
    spanDriftEnd1: '', //最终1
    spanDriftError1: '', //绝对误差
    spanDriftRange1: '', //标准量程
    startTime2: '',
    endTime2: '',
    zeroDriftStart2: '',
    zeroDriftEnd2: '',
    zeroDriftError2: '',
    zeroDriftRange2: '',
    spanDriftStart2: '',
    spanDriftEnd2: '',
    spanDriftError2: '',
    spanDriftRange2: '',
    startTime3: '',
    endTime3: '',
    zeroDriftStart3: '',
    zeroDriftEnd3: '',
    zeroDriftError3: '',
    zeroDriftRange3: '',
    spanDriftStart3: '',
    spanDriftEnd3: '',
    spanDriftError3: '',
    spanDriftRange3: '',
  },
  {
    sort: 5,
    gasesName: 'CO',
    gasesConcentration: '100',
    startTime1: '', //零点漂移起始时间
    endTime1: '',
    zeroDriftStart1: '',
    zeroDriftEnd1: '',
    zeroDriftError1: '', //误差
    zeroDriftRange1: '', //量程
    spanDriftStart1: '', //量程漂移起始1
    spanDriftEnd1: '', //最终1
    spanDriftError1: '', //绝对误差
    spanDriftRange1: '', //标准量程
    startTime2: '',
    endTime2: '',
    zeroDriftStart2: '',
    zeroDriftEnd2: '',
    zeroDriftError2: '',
    zeroDriftRange2: '',
    spanDriftStart2: '',
    spanDriftEnd2: '',
    spanDriftError2: '',
    spanDriftRange2: '',
    startTime3: '',
    endTime3: '',
    zeroDriftStart3: '',
    zeroDriftEnd3: '',
    zeroDriftError3: '',
    zeroDriftRange3: '',
    spanDriftStart3: '',
    spanDriftEnd3: '',
    spanDriftError3: '',
    spanDriftRange3: '',
  },
];
